#ifndef DSTR_H
#define DSTR_H

#include "aliases.h"

typedef struct dstr String;

String *dstr_with_capacity(u64 capacity);
String *dstr_from_string(const char *str);
void dstr_update(String **dst, const char *src);
void dstr_free(String **str);
void dstr_concat(String **dst, const char *src);
void dstr_append(String **dst, char c);
void dstr_resize(String **str);
void dstr_clear(String *str);
void dstr_print(const String *str);
i64 dstr_find(const String *str, const char *substr);
u64 dstr_length(const String *str);
u64 dstr_capacity(const String *str);
const char *dstr_to_cstr(const String *str);

#endif // !DSTR_H
